import scrapy, re


class SjkzrSpider(scrapy.Spider):
    name = 'sjkzr'
    allowed_domains = ['qcc.com']


    def start_requests(self):

        firm_list = ['南京银行','江苏金融租赁','江苏省规划','万向信托','国投泰康信托']

        for firm in firm_list:

            url = 'https://www.qcc.com/web/search?key={}'.format(firm)
            req = scrapy.Request(url, callback=self.get_firm_url)
            req.meta['firm']=firm
            yield req

    def get_firm_url(self, response):
        firm = response.meta['firm']
        firm_url = response.xpath('.//div[@class="maininfo"]')[0].xpath('.//a/@href')[0].get()
        firm_token = re.search('firm/(.*?)\.html', firm_url).group(1)
        detail_url = 'https://www.qcc.com/cbase/{}'.format(firm_token)
        req = scrapy.Request(detail_url, callback=self.get_firm_detail)
        req.meta['firm']=firm
        yield req


    def get_firm_detail(self, response):
        firm = response.meta['firm']
        li = response.xpath('.//span[contains(text(),"实际控制人")]/..')
        if len(li)!=0:
            skr = li[0].xpath('./preceding-sibling::span//text()').get()
            item = scrapy.Item()
            item.fields['firm'] = scrapy.Field()
            item.fields['skr'] = scrapy.Field()
            item['firm'] = firm
            item['skr'] = skr
            yield item

        else:
            x = response.xpath('.//section[@id="partner"]//tr')[1].xpath('.//a/@href')[0].get().split('/')[-1].split('.')[0]
            if len(x)==32:
                url = 'https://www.qcc.com/cbase/{}'.format(x)
            else:
                x = response.xpath('.//section[@id="partner"]//tr')[2].xpath('.//a/@href')[0].get().split('/')[-1].split('.')[0]
                if len(x)==32:
                    url = 'https://www.qcc.com/cbase/{}'.format(x)
                else:
                    x = response.xpath('.//section[@id="partner"]//tr')[3].xpath('.//a/@href')[0].get().split('/')[-1].split('.')[0]
            req = scrapy.Request(url, callback=self.get_firm_detail)
            req.meta['firm']=firm
            yield req